<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: mapper_mgr.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_8adf8e45060761504798219bdd80cc32.html">pam_pkcs11</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">mapper_mgr.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="mapper__mgr_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PKCS #11 PAM Login Module</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright (C) 2003 Mario Strasser &lt;mast@gmx.net&gt;,</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Mapper module copyright (c) 2005 Juan Antonio Martinez &lt;jonsito@teleline.es&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">* this module manages dynamic load of mapping modules</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">* also is used as entry point for cert matching routines</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef _MAPPER_MGR_H_</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define _MAPPER_MGR_H_</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifdef HAVE_CONFIG_H</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;config.h&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &quot;../common/cert_st.h&quot;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &quot;../scconf/scconf.h&quot;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &quot;../mappers/mapper.h&quot;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment">* mapper module descriptor</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="structmapper__instance.html">   38</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structmapper__instance.html">mapper_instance</a> {</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="structmapper__instance.html#a336958ee9ec10f18a0a8bd9e2bf21d87">   39</a></span>&#160;    <span class="keywordtype">void</span> *<a class="code" href="structmapper__instance.html#a336958ee9ec10f18a0a8bd9e2bf21d87">module_handler</a>;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="structmapper__instance.html#a4c2d9327de87c6be0b54f793adc7f1fb">   40</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapper__instance.html#a4c2d9327de87c6be0b54f793adc7f1fb">module_name</a>;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="structmapper__instance.html#a038f61f874f171e16864d8b9a2bd5df9">   41</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="structmapper__instance.html#a038f61f874f171e16864d8b9a2bd5df9">module_path</a>;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="structmapper__instance.html#a5932014fc61839cfaf60693fc68f0b11">   42</a></span>&#160;    <a class="code" href="structmapper__module__st.html">mapper_module</a> *<a class="code" href="structmapper__instance.html#a5932014fc61839cfaf60693fc68f0b11">module_data</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;};</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment">* mapper module list</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="structmapper__listitem.html">   48</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structmapper__listitem.html">mapper_listitem</a> {</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="structmapper__listitem.html#a1d9f5ff9bfbf6cc2f4e13d837ca6471d">   49</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structmapper__instance.html">mapper_instance</a> *<a class="code" href="structmapper__listitem.html#a1d9f5ff9bfbf6cc2f4e13d837ca6471d">module</a>;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="structmapper__listitem.html#a34cd90cb22c15691a3b8e58cb569aa43">   50</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structmapper__listitem.html">mapper_listitem</a> *<a class="code" href="structmapper__listitem.html#a34cd90cb22c15691a3b8e58cb569aa43">next</a>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;};</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment">* load and initialize a module</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">* returns descriptor on success, null on fail</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">struct </span><a class="code" href="structmapper__instance.html">mapper_instance</a> *<a class="code" href="mapper__mgr_8h.html#a23c5ac810d230c8e7be43c2257fa8ccf">load_module</a>(<a class="code" href="structscconf__context.html">scconf_context</a> *ctx, <span class="keyword">const</span> <span class="keywordtype">char</span> * name);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keywordtype">void</span> <a class="code" href="mapper__mgr_8h.html#a3402a94632688ea27a008e4b9a23c2e1">unload_module</a>( <span class="keyword">struct</span> <a class="code" href="structmapper__instance.html">mapper_instance</a> *module );</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">struct </span><a class="code" href="structmapper__listitem.html">mapper_listitem</a> *<a class="code" href="mapper__mgr_8h.html#aae561e15bf3660fe344dd973987eb957">load_mappers</a>( <a class="code" href="structscconf__context.html">scconf_context</a> *ctx );</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keywordtype">void</span> <a class="code" href="mapper__mgr_8h.html#aa87058f025eb28bdf8ed4da80216d169">unload_mappers</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">* this function search mapper module list until</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">* find a module that returns a login name for</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">* provided certificate</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keywordtype">char</span> * <a class="code" href="mapper__mgr_8h.html#a9e23baf57d636c8085bd68ec832a515b">find_user</a>(X509 *x509);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keywordtype">int</span> <a class="code" href="mapper__mgr_8h.html#ac5b85b8aae0f14885e7e28b087e9aab3">match_user</a>(X509 *x509, <span class="keyword">const</span> <span class="keywordtype">char</span> *login);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">* This funcions goest throught the mapper list</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">* and trying to get the certificate strings to be used on each</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">* module to perform find/match functions.</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">* No map / match are done: just print found strings on stdout.</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">* This function is mostly used in pkcert_view toool</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keywordtype">void</span> <a class="code" href="mapper__mgr_8h.html#a051d6e314415a06f81ccd74821f031ee">inspect_certificate</a>(X509 *x509);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structmapper__instance_html_a5932014fc61839cfaf60693fc68f0b11"><div class="ttname"><a href="structmapper__instance.html#a5932014fc61839cfaf60693fc68f0b11">mapper_instance::module_data</a></div><div class="ttdeci">mapper_module * module_data</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00042">mapper_mgr.h:42</a></div></div>
<div class="ttc" id="mapper__mgr_8h_html_aa87058f025eb28bdf8ed4da80216d169"><div class="ttname"><a href="mapper__mgr_8h.html#aa87058f025eb28bdf8ed4da80216d169">unload_mappers</a></div><div class="ttdeci">void unload_mappers(void)</div><div class="ttdoc">unload mapper module chain </div></div>
<div class="ttc" id="mapper__mgr_8h_html_a9e23baf57d636c8085bd68ec832a515b"><div class="ttname"><a href="mapper__mgr_8h.html#a9e23baf57d636c8085bd68ec832a515b">find_user</a></div><div class="ttdeci">char * find_user(X509 *x509)</div></div>
<div class="ttc" id="structmapper__listitem_html"><div class="ttname"><a href="structmapper__listitem.html">mapper_listitem</a></div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00048">mapper_mgr.h:48</a></div></div>
<div class="ttc" id="structmapper__instance_html"><div class="ttname"><a href="structmapper__instance.html">mapper_instance</a></div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00038">mapper_mgr.h:38</a></div></div>
<div class="ttc" id="mapper__mgr_8h_html_a3402a94632688ea27a008e4b9a23c2e1"><div class="ttname"><a href="mapper__mgr_8h.html#a3402a94632688ea27a008e4b9a23c2e1">unload_module</a></div><div class="ttdeci">void unload_module(struct mapper_instance *module)</div><div class="ttdoc">Unload a module. </div></div>
<div class="ttc" id="structmapper__listitem_html_a34cd90cb22c15691a3b8e58cb569aa43"><div class="ttname"><a href="structmapper__listitem.html#a34cd90cb22c15691a3b8e58cb569aa43">mapper_listitem::next</a></div><div class="ttdeci">struct mapper_listitem * next</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00050">mapper_mgr.h:50</a></div></div>
<div class="ttc" id="mapper__mgr_8h_html_a051d6e314415a06f81ccd74821f031ee"><div class="ttname"><a href="mapper__mgr_8h.html#a051d6e314415a06f81ccd74821f031ee">inspect_certificate</a></div><div class="ttdeci">void inspect_certificate(X509 *x509)</div></div>
<div class="ttc" id="mapper__mgr_8h_html_ac5b85b8aae0f14885e7e28b087e9aab3"><div class="ttname"><a href="mapper__mgr_8h.html#ac5b85b8aae0f14885e7e28b087e9aab3">match_user</a></div><div class="ttdeci">int match_user(X509 *x509, const char *login)</div><div class="ttdoc">This function search mapper module list until find a module that match provided login name if login i...</div></div>
<div class="ttc" id="structmapper__module__st_html"><div class="ttname"><a href="structmapper__module__st.html">mapper_module_st</a></div><div class="ttdoc">Structure to be filled on mapper module initialization. </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00040">mapper.h:40</a></div></div>
<div class="ttc" id="structscconf__context_html"><div class="ttname"><a href="structscconf__context.html">scconf_context</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00083">scconf.h:83</a></div></div>
<div class="ttc" id="structmapper__instance_html_a336958ee9ec10f18a0a8bd9e2bf21d87"><div class="ttname"><a href="structmapper__instance.html#a336958ee9ec10f18a0a8bd9e2bf21d87">mapper_instance::module_handler</a></div><div class="ttdeci">void * module_handler</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00039">mapper_mgr.h:39</a></div></div>
<div class="ttc" id="structmapper__listitem_html_a1d9f5ff9bfbf6cc2f4e13d837ca6471d"><div class="ttname"><a href="structmapper__listitem.html#a1d9f5ff9bfbf6cc2f4e13d837ca6471d">mapper_listitem::module</a></div><div class="ttdeci">struct mapper_instance * module</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00049">mapper_mgr.h:49</a></div></div>
<div class="ttc" id="structmapper__instance_html_a038f61f874f171e16864d8b9a2bd5df9"><div class="ttname"><a href="structmapper__instance.html#a038f61f874f171e16864d8b9a2bd5df9">mapper_instance::module_path</a></div><div class="ttdeci">const char * module_path</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00041">mapper_mgr.h:41</a></div></div>
<div class="ttc" id="mapper__mgr_8h_html_a23c5ac810d230c8e7be43c2257fa8ccf"><div class="ttname"><a href="mapper__mgr_8h.html#a23c5ac810d230c8e7be43c2257fa8ccf">load_module</a></div><div class="ttdeci">struct mapper_instance * load_module(scconf_context *ctx, const char *name)</div></div>
<div class="ttc" id="mapper__mgr_8h_html_aae561e15bf3660fe344dd973987eb957"><div class="ttname"><a href="mapper__mgr_8h.html#aae561e15bf3660fe344dd973987eb957">load_mappers</a></div><div class="ttdeci">struct mapper_listitem * load_mappers(scconf_context *ctx)</div><div class="ttdoc">compose mapper module chain </div></div>
<div class="ttc" id="structmapper__instance_html_a4c2d9327de87c6be0b54f793adc7f1fb"><div class="ttname"><a href="structmapper__instance.html#a4c2d9327de87c6be0b54f793adc7f1fb">mapper_instance::module_name</a></div><div class="ttdeci">const char * module_name</div><div class="ttdef"><b>Definition:</b> <a href="mapper__mgr_8h_source.html#l00040">mapper_mgr.h:40</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
